// src/plugin.ts
import { transformSync } from "esbuild";
var scriptRE = /(<script\b(?:\s[^>]*>|>))(.*?)<\/script>/gims;
function pureServer() {
  return {
    name: "vite-plugin-pureServer",
    transform(code, id) {
      let serverScript = "";
      if (!id.includes("node_modules") && /\.vue$/.test(id)) {
        code.replace(scriptRE, (str, tag, script) => {
          if (tag?.includes("server")) {
            serverScript += script;
          }
          return "";
        });
        return transformSync(serverScript, { loader: "ts" }).code;
      }
    }
  };
}
export {
  pureServer,
  scriptRE
};
